"""
Django settings for project.

Generated by 'django-admin startproject' using Django 3.2.9.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""
from os import getenv
from pathlib import Path
from socket import gethostname, gethostbyname_ex

BASE_DIR = Path(__file__).resolve(strict=True).parent.parent

# Use `./manage.py generate_secret_key` to generate a new one
SECRET_KEY = getenv('DJANGO_SECRET_KEY', 'django-insecure-1l_c9eu$a5%8+@m(=1bv6on!m*b(z^w0yk9pc--nhcw61hm#^s')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = getenv('DJANGO_DEBUG', 'True').lower() in ('true', '1', 'on')
TEST_RUNNER = 'runner.PytestTestRunner'

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
    },
    'root': {  # catch all for all loggers
        'handlers': ['console'],
        'level': 'DEBUG',
    },
    'loggers': {
        'django': {
            'handlers': ['console'],
            'level': getenv('DJANGO_LOG_LEVEL', 'INFO' if DEBUG else 'WARNING'),
            'propagate': False,
        },
        'werkzeug': {
            'handlers': ['console'],
            'level': getenv('DJANGO_RUNSERVER_LOG_LEVEL', 'DEBUG' if DEBUG else 'INFO'),
            'propagate': False,
        },
        'asyncio': {
            'level': 'WARNING',
        },
        'flake8': {
            'level': 'ERROR',
        }
    },
}

ALLOWED_HOSTS = ['*']
INTERNAL_IPS = [
    '127.0.0.1',
]
if DEBUG:
    INTERNAL_IPS += [
        # tricks to have debug toolbar when developing with docker
        *[ip[:-1] + '1' for ip in gethostbyname_ex(gethostname())[2]]
    ]

INSTALLED_APPS = [
    'django_pdb',
    'django_extensions',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django_filters',
    'corsheaders',
    'graphene_django',
    # 'debug_toolbar',
    # 'graphiql_debug_toolbar',
    'myapp',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    # 'graphiql_debug_toolbar.middleware.DebugToolbarMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django_pdb.middleware.PdbMiddleware',
]

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'wsgi.application'

# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases
DATABASES = {
    'default': {
        'ENGINE': {
            'postgresql': 'django.db.backends.postgresql',
            'sqlite': 'django.db.backends.sqlite3',
        }[getenv('DJANGO_DB_TYPE', 'postgresql')],
        'HOST': getenv('DJANGO_DB_HOST', 'db'),
        'PORT': getenv('DJANGO_DB_PORT', '5432'),
        'NAME': BASE_DIR / 'myapp.sqlite' if getenv('DJANGO_DB_TYPE', 'postgresql') == 'sqlite' else 'myapp',
        'USER': 'myapp',
        'PASSWORD': 'myapp',
    }
}

AUTH_USER_MODEL = 'myapp.User'
GRAPHENE = {
    'SCHEMA': 'myapp.schema.schema',
    'RELAY_CONNECTION_MAX_LIMIT': None,  # no max objects per graph QL request per default
}

SESSION_COOKIE_AGE = 30 * 86400  # 30 days
if getenv('DJANGO_NO_HTTPS', 'False').lower() not in ('true', '1', 'on'):
    SECURE_HSTS_SECONDS = 365 * 86400  # 1 year
    SECURE_HSTS_INCLUDE_SUBDOMAINS = True
    SECURE_HSTS_PRELOAD = True
    SESSION_COOKIE_SECURE = True
    CSRF_COOKIE_SECURE = True
SILENCED_SYSTEM_CHECKS = []
SILENCED_SYSTEM_CHECKS.append('security.W008')  # SECURE_SSL_REDIRECT is not True
SILENCED_SYSTEM_CHECKS.append('security.W018')  # DJANGO_DEBUG is not False
DEFAULT_AUTO_FIELD = 'django.db.models.AutoField'

# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators
AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'
TIME_ZONE = 'Europe/Paris'
USE_I18N = True
USE_L10N = True
USE_TZ = True

# If proxied, which is often the case
USE_X_FORWARDED_HOST = True

# CORS
# https://github.com/OttoYiu/django-cors-headers#configuration
CORS_ALLOW_ALL_ORIGINS = True
CORS_ALLOW_CREDENTIALS = True

# Shell plus
SHELL_PLUS_POST_IMPORTS = [
    ('pprint', 'pprint'),
    ('inspect', 'getsource'),
    ('django.db.models', 'Subquery'),
    ('django.db.models', 'OuterRef'),
    ('graphql_relay', 'from_global_id'),
    ('graphql_relay', 'to_global_id'),
]

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/
STATIC_URL = '/static/'
STATIC_ROOT = BASE_DIR / 'static'
MEDIA_URL = '/media/'
MEDIA_ROOT = BASE_DIR / 'media'

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field
DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
